'use strict';

$(function() {

    // -------------------- メインイメージ スライダー
    var windowWidth;
    var compareListFlag, lensCarouselFlag;

    var mainCarousel = function(windowWidth){
        var paddingWidth = (windowWidth - 960) / 2;
        $('#mainCarousel').slick({
            accessibility: false,
            autoplay: true,
            autoplaySpeed: 5000,
            pauseOnHover: false,
            arrows: false,
            centerMode: true,
            centerPadding: paddingWidth + 'px',
            infinite: true,
            cssEase: 'ease',
            slidesToShow: 1,
            slidesToScroll: 1,
        });
    };

    $(window).on('load', function() {
        $('.main-image').css('display', 'block');
        windowWidth = $(window).width();
        mainCarousel(windowWidth);
    });

    // -------------------- リサイズ処理
    var timer = false;
    $(window).resize(function() {
        if (timer !== false) {
            clearTimeout(timer);
        }
        timer = setTimeout(function() {
            // 要素高さ揃え
            $(".height_01").tile();
            $(".height_02").tile();
            // メインスライダー
            mainCarouselResize();
        }, 200);
    });

    function mainCarouselResize() {
        $('#mainCarousel').slick('unslick');
        windowWidth = $(window).width();
        mainCarousel(windowWidth);
    }


    // -------------------- YouTube再生用
    $('a[href*="youtube.com/watch"]').magnificPopup({
        type: 'iframe',
        closeMarkup:'<button title="%title%" type="button" class="mfp-close"></button>',
        iframe: {
            patterns: {
                youtube: {
                    index: 'youtube.com',
                    id: 'v=',
                    src: '//www.youtube.com/embed/%id%?rel=0&modestbranding=0&showinfo=0&fs=0&controls=1&autohide=0&vq=hd720&autoplay=1'
                }
            }
        }
    });

    // -------------------- 中国用動画再生
    $('.video-src-list').hide();
    $('.player').magnificPopup({
        type: 'inline',
        closeMarkup:'<button title="%title%" type="button" class="mfp-close"></button>',
        callbacks: {
            open: function() {
                var videoSrc = [];
                var videoId = $('.mfp-content').children('.video_wrap').attr('id');

                for (var i = 1; i < 4; i++) {
                   videoSrc.push($('#' + videoId + ' li:nth-child(' + i + ')').text());
                }

                $('#' + videoId).append(
                   '<video controls preload autoplay>' +
                   '<source src="' + videoSrc[0] + '" type="video/mp4">' +
                   '<source src="' + videoSrc[1] + '" type="video/webm">' +
                   '<source src="' + videoSrc[2] + '" type="video/ogg">' +
                   '</video>'
                );
            },
            close: function() {
                $('.video_wrap').children('video').remove();
                videoSrc = [];
            }
         }
     });


    // -------------------- ボケスライダー用json 取得
    $.ajax({
        type: 'GET',
        url: '/product/dslr/mlens/f12pro/compare-list.json',
        dataType: 'json',
    }).then(getComparelistJson, function(){
        // alert('json取得エラー')
    });

    function getComparelistJson(json) {

        var defaultImgLength = 2,// 初期表示で表示する画像の数
            loadedImgNum = defaultImgLength; // ロードされた画像枚数の変数

        initComparelist();

        // -------------------- ボケ比較初期処理
        function initComparelist() {
            // リスト挿入
            for (var i = 1; i < json.length + 1; i++) {
                $('#compare-list').append('<div class="compare-wrap"><div class="compare_01 bg_02"><div class="compare-photo"></div><p class="text_04">' + json[i - 1].capLeft + '</p></div><div class="compare_02 bg_02"><div class="compare-photo"></div><p class="text_04">' + json[i - 1].capRight + '</p></div></div>');
            }
            // 初期表示画像挿入
            for (var j = 1; j < defaultImgLength +1; j++) {
                $('.compare-wrap:nth-child(' + j + ') .compare_01 .compare-photo').append('<img src="' + json[j - 1].imgLeft + '" alt="" />');
                $('.compare-wrap:nth-child(' + j + ') .compare_02 .compare-photo').append('<img src="' + json[j - 1].imgRight + '" alt="" />');
            }

            $(window).on('load', function() {
                compareList();
            });
        } // initComparelist


        // -------------------- ボケスライダー 1カラム時縦写真高さ調整
        var timer = false,
            windowWidth,
            compareWrapLength,
            eachPhotoHeight,
            comparePhotoHeight;

        $(window).on('load resize compare:lazy', function() {
            if (timer !== false) {
                clearTimeout(timer);
            }
            timer = setTimeout(function() {
                $('#compare-list img').css('height', '');
                windowWidth = $(window).width();
                if(windowWidth <= 640){
                    comparePhotoHeight = 540;
                    compareWrapLength =$('#compare-list .compare-wrap').length;
                    for (var i = 1; i < compareWrapLength + 1; i++) {
                        eachPhotoHeight = $('#compare-list .compare-wrap:nth-of-type(' + i + ')  .compare_01 img').height();
                        if (eachPhotoHeight < comparePhotoHeight && eachPhotoHeight != null) {
                            comparePhotoHeight = eachPhotoHeight;
                        }
                    }
                    $('#compare-list img').height(comparePhotoHeight);
                } else {
                    $('#compare-list img').css('height', '');
                }
            }, 200);
        });

        // スライダー発火
        function compareList() {
            $('#compare-list').slick({
                infinite: false,
                cssEase: 'ease',
                slidesToShow: 1,
                slidesToScroll: 1
            }).on('swipe', bokehImgLoad).on('click', '.slick-next', function() {
                bokehImgLoad();
            });
            compareListFlag = true;
            pageScroll();
        } // compareList



        // -------------------- ボケスライダー 画像遅延読み込み
        function bokehImgLoad(){
            var addImgLength = 1; // スライダー1クリックでロードする画像の数

            if (loadedImgNum < json.length) {
                for (var i = loadedImgNum + 1; i < loadedImgNum + 1 + addImgLength; i++) {
                    $('.compare-wrap:nth-child(' + i + ') .compare_01 .compare-photo').append('<img src="' + json[i - 1].imgLeft + '" alt="" />');
                    $('.compare-wrap:nth-child(' + i + ') .compare_02 .compare-photo').append('<img src="' + json[i - 1].imgRight + '" alt="" />');
                }
                loadedImgNum += addImgLength;
            }
            $(window).trigger('compare:lazy');
        } // bokehImgLoad


    } // getComparelistJson


    // -------------------- レンズ別ギャラリー用json 取得
    $.ajax({
        type: 'GET',
        url: '/product/dslr/mlens/f12pro/gallery.json',
        dataType: 'json',
    }).then(getJson, function(){
        // alert('json取得エラー')
    });

    function getJson(json) {

        // jsonシャッフル
        for(var i = json.length - 1; i > 0; i--){
            var j = Math.floor(Math.random() * (i + 1));
            var tmp = json[i];
            json[i] = json[j];
            json[j] = tmp;
        }

        // jsonをレンズ別で絞込み
        var jsonLens17mm = json.filter(function(item, index) {if (item.lensType === 'lens17mm') return true;}), // 17mmレンズのみのjson
            jsonLens25mm = json.filter(function(item, index) {if (item.lensType === 'lens25mm') return true;}), // 25mmレンズのみのjson
            jsonLens45mm = json.filter(function(item, index) {if (item.lensType === 'lens45mm') return true;}); // 45mmレンズのみのjson

        var defaultImgLength = 16, // 初期表示で表示する画像の数
            loadedImgNum = defaultImgLength; // ロードされた画像枚数の変数

        initGallery();

        // -------------------- レンズ別ギャラリー初期処理
        function initGallery() {
            // All リスト挿入
            for (var i = 1; i < json.length + 1; i++) {
                $('#lensCarousel').append('<div class="galleryImg' + ('0' + i).slice(-2) + ' ' + json[i - 1].lensType + '"><a href="' + json[i - 1].linkPath + '" title="' + json[i - 1].imgCaption + '"></a></div>');
            }
            // 初期表示画像挿入
            for (var j = 1; j < defaultImgLength +1; j++) {
                $('#lensCarousel div:nth-child(' + j + ') a').append('<img src="' + json[j - 1].imgPath + '" alt="" />');
            }

            slickCarousel();
        }

        // -------------------- スライダープラグイン発火
        function slickCarousel() {
            $('#lensCarousel').slick({
                infinite: false,
                cssEase: 'ease',
                slidesToShow: 1,
                slidesToScroll: 1,
                rows: 8,
                responsive: [
                    {
                        breakpoint: 640,
                        settings: {
                            rows: 6
                        }
                    }
                ]
            }).on('swipe', lensImgLoad).on('click', '.slick-next', lensImgLoad);

            lensCarouselFlag = true;
            pageScroll();
        }

        // -------------------- レンズ別ギャラリーALL 画像遅延読み込み
        function lensImgLoad(){
            var addImgLength = 8; // スライダー1クリックでロードする画像の数

            if($('#lensAll').hasClass('active')) {

                if (loadedImgNum < json.length) {
                    for (var i = loadedImgNum + 1; i < loadedImgNum + 1 + addImgLength; i++) {
                        $('#lensCarousel .galleryImg' + ('0' + i).slice(-2)).append('<a href="' + json[i - 1].linkPath + '" title="' + json[i - 1].imgCaption + '"><img src="' + json[i - 1].imgPath + '" alt="" /></a>');
                        if (i >= json.length) {break;}
                    }
                    loadedImgNum += addImgLength;
                }
            }
        }

        // -------------------- レンズ別ギャラリー画像絞込
        $('.filterBtn').on('click', function(){
            filterGallery($(this).attr('id'));
        });

        function filterGallery(filteredLense) {

            $('.filterBtn').removeClass('active');
            $('#lensCarousel').slick('unslick').children().remove();

            if (filteredLense === 'lens17mm') {
                $('#lens17mm').addClass('active');
                for (var i = 1; i < jsonLens17mm.length + 1; i++) {
                    $('#lensCarousel').append('<div class="galleryImg' + ('0' + i).slice(-2) + ' ' + jsonLens17mm[i - 1].lensType + '"><a href="' + jsonLens17mm[i - 1].linkPath + '" title="' + jsonLens17mm[i - 1].imgCaption + '"><img src="' + jsonLens17mm[i - 1].imgPath + '" alt="" /></a></div>');
                }
            } else if (filteredLense === 'lens25mm') {
                $('#lens25mm').addClass('active');
                for (var j = 1; j < jsonLens25mm.length + 1; j++) {
                    $('#lensCarousel').append('<div class="galleryImg' + ('0' + j).slice(-2) + ' ' + jsonLens25mm[j - 1].lensType + '"><a href="' + jsonLens25mm[j - 1].linkPath + '" title="' + jsonLens25mm[j - 1].imgCaption + '"><img src="' + jsonLens25mm[j - 1].imgPath + '" alt="" /></a></div>');
                }
            } else if (filteredLense === 'lens45mm') {
                $('#lens45mm').addClass('active');
                for (var k = 1; k < jsonLens45mm.length + 1; k++) {
                    $('#lensCarousel').append('<div class="galleryImg' + ('0' + k).slice(-2) + ' ' + jsonLens45mm[k - 1].lensType + '"><a href="' + jsonLens45mm[k - 1].linkPath + '" title="' + jsonLens45mm[k - 1].imgCaption + '"><img src="' + jsonLens45mm[k - 1].imgPath + '" alt="" /></a></div>');
                }
            } else {
                $('#lensAll').addClass('active');
                loadedImgNum = defaultImgLength;
                initGallery();
                return false;
            }
                slickCarousel();

        } // filterGallery

    } // getJson


    // -------------------- モーダル
    $('#lensCarousel').magnificPopup({
        delegate: 'a',
        type: 'image',
        closeMarkup:'<button title="%title%" type="button" class="mfp-close"></button>',
        image: {
            markup: '<div class="mfp-close"></div>'+
                    '<div class="mfp-figure">'+
                        '<figure>'+
                            '<div class="mfp-img"></div>'+
                            '<figcaption>'+
                                '<div class="mfp-bottom-bar">'+
                                    '<div class="mfp-title"></div>'+
                                    '<div class="mfp-counter"></div>'+
                                '</div>'+
                            '</figcaption>'+
                        '</figure>'+
                    '</div>'
        },
        gallery: {
            enabled:true
        },
        callbacks: {
            open: function() {
                var mfp = $.magnificPopup.instance;
                var proto = $.magnificPopup.proto;

                if (!mfp.index) {
                    mfp.arrowLeft.hide();
                }
                if (mfp.index === mfp.items.length - 1) {
                   mfp.arrowRight.hide();
                }

                mfp.next = function() {
                    proto.next.call(mfp);
                    if(mfp.index < mfp.items.length - 1) {
                        mfp.arrowLeft.show();
                    } else {
                        mfp.arrowRight.hide();
                    }
                };

                mfp.prev = function() {
                    proto.prev.call(mfp);
                    if(mfp.index > 0) {
                        mfp.arrowRight.show();
                    } else {
                        mfp.arrowLeft.hide();
                    }
                };

            }
        } // callbacks
    });


	// -------------------- 要素高さ揃え
    $(".height_01").tile();
    $(".height_02").tile();


    // -------------------- 写真家表示順ランダム
    var randomContent = [],
        i;
    $('#photographers-list li.ramdom').each(function() {
    	randomContent.push($(this).html());
    });
    randomContent.sort(function() {
    	return Math.random() - Math.random();
    });
    $('#photographers-list li.ramdom').empty();
    i = 0;
    $('#photographers-list li.ramdom').each(function() {
    	$(this).append(randomContent[i]);
    	i++;
    });

    function pageScroll() {
      var ahash, gotoNum;
      if (compareListFlag && lensCarouselFlag) {
        ahash = location.hash;
        if(ahash){
          gotoNum = $(ahash).offset().top;
          $('html,body').scrollTop(gotoNum);
          return false;
        }
      }
    }
});